<template>
  <q-card class="bg-transparent no-shadow no-border">
    <q-card-section class="q-pa-none">
      <div class="row justify-center q-col-gutter-sm">
        <template v-if="Object.keys(datos).length === 0">
          <div
            class="col-md-3 col-sm-12 col-xs-12"
            v-for="index in skeleton"
            :key="index"
          >
            <div class="col q-pa-sm shadow-2">
              <q-skeleton type="text" square width="30%" animation="fade" />
              <q-skeleton type="text" square height="12px" animation="fade" />
              <q-skeleton
                type="text"
                square
                height="12px"
                width="75%"
                animation="fade"
              />
            </div>
          </div>
        </template>
        <template v-if="datos.length != 0">
          <div
            v-for="(item, index) in datos"
            :key="index"
            class="col-md col-xs-12"
          >
            <!-- :class="ancho + ' col-sm-12 col-xs-12'" -->
            <!-- col-sm-12 col-xs-12 -->
            <q-item
              clickable
              :class="`bg-${item.color}`"
              class="shadow-2"
              :to="item.link"
              @click="$emit('accion', item.accion)"
            >
              <q-item-section
                v-if="icon_position === 'left'"
                :class="`bg-${item.color}`"
                side
                class="q-pa-lg q-mr-none text-white"
              >
                <q-icon :name="item.icono" color="white" size="24px"></q-icon>
              </q-item-section>
              <q-item-section class="q-pa-md q-ml-none text-white">
                <q-item-label class="text-white text-h4 text-weight-regular">{{
                  item.valor
                }}</q-item-label>
                <q-item-label class="text-weight-medium">{{
                  item.titulo
                }}</q-item-label>
              </q-item-section>
              <q-item-section
                v-if="icon_position === 'right'"
                side
                class="q-mr-md text-white"
              >
                <q-icon :name="item.icono" color="white" size="44px"></q-icon>
              </q-item-section>
            </q-item>
          </div>
        </template>
      </div>
    </q-card-section>
  </q-card>
</template>

<script lang="ts">
import { defineComponent, PropType } from 'vue';

export interface CardWidgetType {
  titulo: string;
  color: string;
  icono: string;
  accion?: string;
  link?: string;
  valor: number;
}

export default defineComponent({
  name: 'CardWidget',
  props: {
    icon_position: {
      required: false,
      default: 'left',
    },
    datos: {
      type: Object as PropType<CardWidgetType[]>,
      required: true,
    },
    skeleton: {
      type: Number,
      default: 4,
      required: false,
    },
  },
});
</script>
